//
//  AllJobsViewController.m
//  iTimesheet
//
//  Created by Mark Brindle on 05/04/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import "AllJobsTableViewController.h"
#import "JobTableViewCell.h"
#import "PPJob.h"
#import "PPJob-Timecard.h"
#import "PPJob-TimeSpent.h"
#import "PPTimecard.h"
#import "iTimesheetAppDelegate.h"
#import "TimecardTableViewController.h"
#import "InsertJobViewController.h"


@implementation AllJobsTableViewController

// Manually synthesize our property
@synthesize jobs;


#pragma mark - boilerplate code (provided by template)

- (id)initWithStyle:(UITableViewStyle)style
{
  self = [super initWithStyle:style];
  if (self) {
    // Custom initialization
  }
  return self;
}

- (void)didReceiveMemoryWarning
{
  // Releases the view if it doesn't have a superview.
  [super didReceiveMemoryWarning];
  
  // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidUnload
{
  [super viewDidUnload];
  // Release any retained subviews of the main view.
  // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated {
  [super viewWillAppear:animated];
}


- (void)viewDidAppear:(BOOL)animated
{
  [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
  [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
  [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
  // Return YES for supported orientations
  return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

/*
 // Override to support conditional editing of the table view.
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the specified item to be editable.
 return YES;
 }
 */

/*
 // Override to support editing the table view.
 - (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
 {
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 // Delete the row from the data source
 [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
 }   
 else if (editingStyle == UITableViewCellEditingStyleInsert) {
 // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
 }   
 }
 */

/*
 // Override to support rearranging the table view.
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
 {
 }
 */

/*
 // Override to support conditional rearranging of the table view.
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }
 */

#pragma mark - Table view delegate


#pragma mark - Existing methods (in the original template) that were amended

- (void)dealloc
{
  // Relinquish our interest in the jobs array
  [jobs release];
  [super dealloc];
}

- (void)viewDidLoad
{
  [super viewDidLoad];
  [self setTitle:[NSString stringWithFormat:@"All jobs"]];
  // Uncomment the following line to preserve selection between presentations.
  // self.clearsSelectionOnViewWillAppear = NO;
  
  // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
  // self.navigationItem.rightBarButtonItem = self.editButtonItem;
  
  // Get a list of all jobs from core data
  iTimesheetAppDelegate *ad = [iTimesheetAppDelegate sharedAppDelegate];
  NSArray *list = [ad allInstancesOf:@"Job" orderedBy:@"name"];
  [self setJobs:[list mutableCopy]];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
  // Return the number of sections.
  // We are not grouping data in any way, so we only have one section.
  return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
  // Return the number of rows in the section.
  // We want one row for each job, so return the number of entries in our jobs 
  // array.
  return [jobs count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
  // A unique identifier for cells
  static NSString *CellIdentifier = @"AllJobCellIdentifier";
  
  // Try to reuse a cell if possible
  JobTableViewCell *cell = 
  (JobTableViewCell *)[tableView dequeueReusableCellWithIdentifier:CellIdentifier];
  
  // If we couldn't get a cell to reuse then we need to create one.
  if (cell == nil) {
    NSArray *nib = [[NSBundle mainBundle] 
                    loadNibNamed:@"JobTableViewCell" 
                    owner:self 
                    options:nil];
    for (id oneObject in nib) {
      if ([oneObject isKindOfClass:[JobTableViewCell class]]) {
        cell = (JobTableViewCell *)oneObject;
      }
    }
  }
  
  // Get the job from our array that corresponds to this row; using the row
  // as an index into the array.
  PPJob *job = [[self jobs] objectAtIndex:[indexPath row]];
  
  // Fill cell details from the job
  cell.projectField.text = [[job project] name];
  cell.jobField.text = [job name];
  cell.jobDescField.text = [job desc];
  cell.jobHoursField.text = [job timeSpentText];
  if ([job hasTimecards] > 0) {
    if ([[job lastTimecard] end] == nil) {
      cell.jobStatusImage.image = [UIImage imageNamed:@"Stop.png"];
    } else {
      cell.jobStatusImage.image = [UIImage imageNamed:@"Go.png"];
    }
    // If we have any detail data set a detail disclosure button
    [cell setAccessoryType:UITableViewCellAccessoryDetailDisclosureButton];
  } else {
    cell.jobStatusImage.image = [UIImage imageNamed:@"Go.png"];
  }
  
  // Return the populated cell.
  return cell;
}

-(void)tableView:(UITableView *)tableView 
didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
  // Called when cell is tapped to start / stop a timesheet entry
  
  // Get a reference to the job corresponding to this row
  PPJob *job = [[self jobs] objectAtIndex:[indexPath row]];
  if ([job hasTimecards]) {
    // Get last timecard
    PPTimecard *lastTimecard = [job lastTimecard];
    if ([lastTimecard end] == nil) {
      // Set the end date for this timecard
      NSDate *now = [[NSDate alloc] init];
      [lastTimecard setEnd:now];
      [now release];
    } else {
      // Create a new Timecard
      [self createTimecard:job];
    }
  } else {
    // Create a new Timecard
    [self createTimecard:job];
  }
  [[self tableView] reloadData];
}

#pragma mark - Added methods (did not exist in original template code)

-(CGFloat)tableView:(UITableView *)tableView
heightForRowAtIndexPath:(NSIndexPath *)indexPath {
  // Set the row height to allow for our cell's height
  return kAllJobsViewRowHeight;
}

- (void)createTimecard:(PPJob *)job {
  // Create a timecard entry via core data's managed object context
  iTimesheetAppDelegate *ad = [iTimesheetAppDelegate sharedAppDelegate];
  NSManagedObjectContext *moc = [ad managedObjectContext];
  PPTimecard *tc = [NSEntityDescription 
                    insertNewObjectForEntityForName:@"Timecard"
                    inManagedObjectContext:moc];
  
  // Set the job's start time
  [tc setJob:job];
  NSDate *now = [[NSDate alloc] init];
  [tc setStart:now];
  [now release];
}

-(void)tableView:(UITableView *)tableView 
accessoryButtonTappedForRowWithIndexPath:(NSIndexPath *)indexPath {
  // Called when disclosure button is tapped to display Timecards.  
  
  // Create a timecard view controller
  TimecardTableViewController *vc = [[TimecardTableViewController alloc] init];
  
  // Give a reference to the current job to the view controller
  [vc setJob:[jobs objectAtIndex:[indexPath row]]];
  
  // Push the view controller onto our navigation controllers stack.
  [[self navigationController] pushViewController:vc animated:YES];
  
  // We are no longer concerned with the view so we can relinquish our interest
  // in it.
  [vc release];
}

@end
