//
//  InsertCostCentreViewController.m
//  iTimesheet
//
//  Created by Mark Brindle on 09/04/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import "InsertCostCentreViewController.h"


@implementation InsertCostCentreViewController
@synthesize nameField;
@synthesize ratePicker;

// Manually added synthesize for our manually added properties
@synthesize unitTypes;
@synthesize rateTypes;
@synthesize costCentreName;
@synthesize costCentreRate;
@synthesize costCentreUnit;

#pragma mark - boilerplate code (provided by template)

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Existing methods (in the original template) that were amended

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    return [self init];
//    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
//    if (self) {
//        // Custom initialization
//    }
//    return self;
}

- (void)dealloc
{
    [nameField release];
    [ratePicker release];
    // Release memory for manually added properties
    [unitTypes release];
    [rateTypes release];
    [costCentreName release];
    [costCentreRate release];
    [costCentreUnit release];
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    // Create an array to display unit, and another to display rate, choices.
    NSArray *unitsArray = [[NSArray alloc] initWithObjects:@"£", @"$", @"€", nil];
    [self setUnitTypes:unitsArray];
    [unitsArray release];
    
    NSArray *ratesArray = [[NSArray alloc] 
                           initWithObjects:@"5", @"10", @"15", @"20", @"25",
                           @"30", @"35", @"40", @"45", @"50", @"55", @"60",
                           @"65", @"70", @"75", @"80", @"85", @"90", @"95", 
                           nil];
    [self setRateTypes:ratesArray];
    [ratesArray release];
}

- (void)viewDidUnload
{
    [self setNameField:nil];
    [self setRatePicker:nil];
    // Manually nil out our property references
    [self setUnitTypes:nil];
    [self setRateTypes:nil];
    [self setCostCentreName:nil];
    [self setCostCentreRate:nil];
    [self setCostCentreUnit:nil];
    
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

#pragma mark - Added methods (did not exist in original template code)

- (id)init {
    [super initWithNibName:nil bundle:nil];
    [self setTitle:@"New Record"];
    // Set up navigation items
    UIBarButtonItem *bbi;
    
    // Done item
    bbi = [[UIBarButtonItem alloc]
           initWithBarButtonSystemItem:UIBarButtonSystemItemDone 
           target:self
           action:@selector(create:)];
    [[self navigationItem]setRightBarButtonItem:bbi];
    [bbi release];
    
    // Cancel item
    bbi = [[UIBarButtonItem alloc] 
           initWithBarButtonSystemItem:UIBarButtonSystemItemCancel 
           target:self 
           action:@selector(cancel:)];
    
    return self;
}

// Manage data entered by the user

- (IBAction)create:(id)sender {
    // Set values provided by user
    [self setCostCentreName:[nameField text]];
    // Get the selected row for both unit and rate
    NSInteger unitRow = [[self ratePicker] selectedRowInComponent:kUnitComponent];
    NSInteger rateRow = [[self ratePicker] selectedRowInComponent:kRateComponent];
    // Get the value selected for unit and rate from the respective array
    [self setCostCentreUnit:[[self unitTypes] objectAtIndex:unitRow]];
    [self setCostCentreRate:[[self rateTypes] objectAtIndex:rateRow]];
    // Slide back to the previous view controller
    [[self navigationController] popViewControllerAnimated:YES];
}

- (IBAction)cancel:(id)sender {
    // Clear out any values set by the user
    [self setCostCentreName:nil];
    [self setCostCentreRate:nil];
    [self setCostCentreUnit:nil];
    // Slide back to the previous view controller
    [[self navigationController] popViewControllerAnimated:YES];
}

// Picker Datasource Methods

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {
    return 2;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView 
numberOfRowsInComponent:(NSInteger)component {
    if (component == kUnitComponent) {
        return [[self unitTypes] count];
    }
    return [[self rateTypes] count];
}

// Picker Delegate Methods
- (NSString *)pickerView:(UIPickerView *)pickerView
             titleForRow:(NSInteger)row 
            forComponent:(NSInteger)component {
    if (component == kUnitComponent) {
        return [[self unitTypes] objectAtIndex:row];
    }
    return [[self rateTypes] objectAtIndex:row];
}

// Text field delegate methods

- (IBAction)nameFieldDoneEditing:(id)sender {
  [sender resignFirstResponder];
}

@end
