//
//  PPJob.m
//  iTimesheet
//
//  Created by Mark Brindle on 10/04/2011.
//  Copyright (c) 2011 ARKEMM Software Limited. All rights reserved.
//

#import "PPJob.h"
#import "PPProject.h"
#import "PPTimecard.h"


@implementation PPJob
@dynamic hourlyRate;
@dynamic timeSpent;
@dynamic name;
@dynamic desc;
@dynamic unit;
@dynamic timecards;
@dynamic project;

- (void)addTimecardsObject:(PPTimecard *)value {    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"timecards" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"timecards"] addObject:value];
    [self didChangeValueForKey:@"timecards" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)removeTimecardsObject:(PPTimecard *)value {
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"timecards" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"timecards"] removeObject:value];
    [self didChangeValueForKey:@"timecards" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)addTimecards:(NSSet *)value {    
    [self willChangeValueForKey:@"timecards" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"timecards"] unionSet:value];
    [self didChangeValueForKey:@"timecards" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
}

- (void)removeTimecards:(NSSet *)value {
    [self willChangeValueForKey:@"timecards" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"timecards"] minusSet:value];
    [self didChangeValueForKey:@"timecards" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
}



@end
