//
//  PPProject-TimeSpentText.m
//  iTimesheet
//
//  Created by Mark Brindle on 08/04/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import "PPProject-TimeSpentText.h"
#import "PPProject-SortedJobs.h"
#import "PPJob-TimeSpent.h"
#import "PPJob-Cost.h"

@implementation PPProject (PPProject_TimeSpentText)

- (NSString *)timeSpentText {
  
  double jobTime = 0.0;
  double days = 0.0;
  double hrs = 0.0;
  double mins = 0.0;
  double secs = 0.0;
  
  NSArray *jobsArray = [self sortedJobs];
  for (PPJob *job in jobsArray) {
    jobTime += [[job timeSpent] doubleValue];
  }
  
  NSLog(@"Project jobTime: %f", jobTime);
  if (jobTime > 86400.0) {
    // Get Days
    modf(jobTime / 86400.0, &days);
    jobTime -= (days * 86400.0);
  }
  if (jobTime > 3600.0) {
    // Get hrs
    modf(jobTime / 3600.0, &hrs);
    jobTime -= (hrs * 3600.0);
  }
  if (jobTime > 60.0) {
    // Get mins
    modf(jobTime / 60.0, &mins);
    jobTime -= (mins * 60.0);
  }
  secs = jobTime;
  
  // Now construct result string
  if (days > 0.0) {
    return [NSString stringWithFormat:@"%.1f days", days + hrs / 24.0];
  }
  if (hrs > 0.0) {
    return [NSString stringWithFormat:@"%.1f hrs", hrs + mins / 60.0];
  }
  if (mins > 0.0) {
    return [NSString stringWithFormat:@"%.1f mins", mins + secs / 60.0];
  }
  return [NSString stringWithFormat:@"%.0f secs", secs];
}

- (NSString *)costText {
  double jobCost = 0.0;
  
  NSArray *jobsArray = [self sortedJobs];
  for (PPJob *job in jobsArray) {
    jobCost += [[job cost] doubleValue];
  }
  
  // Now construct result string
  return [NSString stringWithFormat:@"£%.2f", jobCost];
}

@end
