//
//  TimecardTableViewController.m
//  iTimesheet
//
//  Created by Mark Brindle on 04/04/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import "TimecardTableViewController.h"
#import "PPJob.h"
#import "PPJob-Timecard.h"
#import "PPTimecard.h"
#import <math.h>

@implementation TimecardTableViewController

// Manually added to synthesize our properties
@synthesize timecards;
@synthesize job;

#pragma mark - boilerplate code (provided by template)

- (id)initWithStyle:(UITableViewStyle)style
{
  self = [super initWithStyle:style];
  if (self) {
    // Custom initialization
  }
  return self;
}

- (void)didReceiveMemoryWarning
{
  // Releases the view if it doesn't have a superview.
  [super didReceiveMemoryWarning];
  
  // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidUnload
{
  [super viewDidUnload];
  // Release any retained subviews of the main view.
  // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
  [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
  [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
  [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
  [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
  // Return YES for supported orientations
  return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

/*
 // Override to support conditional editing of the table view.
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the specified item to be editable.
 return YES;
 }
 */

/*
 // Override to support editing the table view.
 - (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
 {
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 // Delete the row from the data source
 [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
 }   
 else if (editingStyle == UITableViewCellEditingStyleInsert) {
 // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
 }   
 }
 */

/*
 // Override to support rearranging the table view.
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
 {
 }
 */

/*
 // Override to support conditional rearranging of the table view.
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }
 */

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
  // Navigation logic may go here. Create and push another view controller.
  /*
   <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
   // ...
   // Pass the selected object to the new view controller.
   [self.navigationController pushViewController:detailViewController animated:YES];
   [detailViewController release];
   */
}


#pragma mark - Existing methods (in the original template) that were amended

- (void)dealloc
{
  // Relinquish our interest in memory associated with our manually added 
  // properties
  [job release];
  [timecards release];
  [super dealloc];
}

- (void)viewDidLoad
{
  [super viewDidLoad];
  
  [self setTitle:[NSString stringWithFormat:@"Timecard"]];
  // Uncomment the following line to preserve selection between presentations.
  // self.clearsSelectionOnViewWillAppear = NO;
  
  // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
  // self.navigationItem.rightBarButtonItem = self.editButtonItem;
  
  // Get a list of timecards from the job
  NSArray *list = [job sortedTimecards];
  [self setTimecards:[list mutableCopy]];
  
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
  // Return the number of sections.
  return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
  // Return the number of rows in the section.
  
  // We want one row for each timecard, so return the count of timecard records
  // obtined from the job.
  return [timecards count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
  // A unique identifier for our table cells.
  static NSString *CellIdentifier = @"Cell";
  
  // try and reuse a cell if one is available
  UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
  
  // We couldn't get a cell, so we need to create one
  if (cell == nil) {
    cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
  }
  
  // Configure the cell...
  
  // Get the timecard that corresponds to the row we are filling
  NSUInteger row = [indexPath row];
  PPTimecard *tc = [timecards objectAtIndex:row];
  
  // Set cell details from this timecard
  [[cell textLabel] setNumberOfLines:2];
  [[cell textLabel] 
   setText:[NSString stringWithFormat:@"Start:\t%@\nEnd:\t\t%@",
            [NSDateFormatter localizedStringFromDate:[tc start] 
                                           dateStyle:NSDateFormatterMediumStyle
                                           timeStyle:NSDateFormatterMediumStyle],
            [NSDateFormatter localizedStringFromDate:[tc end]
                                           dateStyle:NSDateFormatterMediumStyle
                                           timeStyle:NSDateFormatterMediumStyle]]];
  
  // We are going to shade alternate rows, so work out if we are on an odd or
  // even row and set the background accordingly.
  double intPart;
  if (modf(row / 2.0, &intPart) > 0.0) {
    UIView *bgView = [[UIView alloc] init];
    bgView.backgroundColor = [UIColor lightGrayColor];
    cell.backgroundView = bgView;
    [[cell textLabel] setBackgroundColor:[UIColor lightGrayColor]];
    // release object
    [bgView release];
  }
  return cell;
}

#pragma mark - Added methods (did not exist in original template code)

-(CGFloat)tableView:(UITableView *)tableView
heightForRowAtIndexPath:(NSIndexPath *)indexPath {
  // Set the height of the row to accommodate the cell's height.
  return kTimecardViewRowHeight;
}

@end
